import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends ScaleCanvas implements MouseListener,MouseMotionListener {
    AffineTransform A;

    Color COLOR;

     public ControlCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 setScales(150,150,300);
     }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawMe(g);

   }

    public void drawMe(Graphics2D g) {
	Path2D.Double pd=unitSquare();
	g.setStroke(new BasicStroke(5));
	pd=transform(pd);
	g.setColor(Color.yellow);
	g.draw(pd);
	g.setStroke(new BasicStroke(1));


	Path2D.Double gp=randomJunk();
	gp=transform(gp);
	g.setColor(new Color(255,0,200,100));
	g.fill(gp);
	g.setColor(Color.white);
	g.draw(gp);

	drawPoint(g,new Complex(.3,.4),6,Color.white);
    }

    public void drawPoint(Graphics2D g,Complex z,int thickness,Color C) {	
        Path2D.Double gp=new Path2D.Double();
	gp.moveTo(z.x,z.y);
	gp.lineTo(z.x,z.y);
	gp=transform(gp);
	g.setColor(C);
	g.setStroke(new BasicStroke(thickness));
	g.fill(gp);
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }



    public Path2D.Double unitSquare() {
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(0,0);
	gp.lineTo(0,1);
	gp.lineTo(1,1);
	gp.lineTo(1,0);
	gp.closePath();
	return(gp);
    }


    public Path2D.Double randomJunk() {
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(0,0);
	for(int i=0;i<30;++i) {
	    gp.lineTo(Math.random(),Math.random());
	}
	gp.closePath();
	return gp;
    }


    
    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	if(J.mode==1) scaleUp(J.X,-1);
	if(J.mode==3) scaleUp(J.X,1);
	if(J.mode==2) SOURCE=unTransform(J.X);
	SOURCE.print();
	System.out.println(J.X.x+" "+J.X.y);

	repaint();
    }

    public void mousePressed(MouseEvent e) {}
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   
     public void mouseMoved(MouseEvent e) {}    
     public void mouseDragged(MouseEvent e) {
     } 

}

